Mojo: Continuous Delivery for Juju
==================================

Mojo is a system of configuration and tools for verifying the success of Juju
environment deployments.

To get started with mojo, on trusty or utopic (using the mojo-how-to spec as an
example):

 1. Install Mojo:

    * Add ppa:mojo-maintainers/ppa to your system's Software Sources
    * sudo apt-get install mojo

 2. Create a project:
 
    * sudo mojo project-new --series trusty mojo-how-to
    * Add the user account in question to the %mojo group

 3. Create a workspace:

    * mojo workspace-new --project mojo-how-to --stage=mojo-how-to/devel --series trusty lp:~mojo-maintainers/mojo/mojo-specs mojo-how-to
    * If that fails with a permission denied error on the lxc folder, this is due to a known bug - "sudo chmod 755 /var/lib/lxc/mojo-how-to.trusty && sudo chmod 755 /var/lib/lxc" will fix it.

 4. Bootstrap your juju environment (not covered here)

 5. Run your mojo spec to configure your environment as specified in the mojo spec:

    * mojo run --project mojo-how-to --series trusty --stage mojo-how-to/devel
    * lp:~mojo-maintainers/mojo/mojo-specs mojo-how-to

For more information on using Mojo see our more detailed [readme](readme.html)
or take a look at these articles which originally appeared on [Ubuntu
Insights](https://insights.ubuntu.com):

 * [Introduction to Mojo](mojo-insights-article-introduction.html)
 * [Mojo Deeper Dive](mojo-insights-article-deeper-dive.html)
 * [Mojo Example Deployment](mojo-insights-article-example-deployment.html)
